BCPGInputStream
Date: 2016-06-23

org.bouncycastle.bcpg

## Class BCPGInputStream

- java.lang.Object
- - java.io.InputStream
  - - org.bouncycastle.bcpg.BCPGInputStream

- All Implemented Interfaces:
    java.io.Closeable, java.lang.AutoCloseable, PacketTags

      public class BCPGInputStream
      extends java.io.InputStream
      implements PacketTags

  Stream reader for PGP objects

- - ### Field Summary

    - ### Fields inherited from interface org.bouncycastle.bcpg.PacketTags

      `COMPRESSED_DATA, EXPERIMENTAL_1, EXPERIMENTAL_2, EXPERIMENTAL_3, EXPERIMENTAL_4, LITERAL_DATA, MARKER, MOD_DETECTION_CODE, ONE_PASS_SIGNATURE, PUBLIC_KEY, PUBLIC_KEY_ENC_SESSION, PUBLIC_SUBKEY, RESERVED, SECRET_KEY, SECRET_SUBKEY, SIGNATURE, SYM_ENC_INTEGRITY_PRO, SYMMETRIC_KEY_ENC, SYMMETRIC_KEY_ENC_SESSION, TRUST, USER_ATTRIBUTE, USER_ID`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BCPGInputStream(java.io.InputStream in)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `available()`
    `void` | `close()`
    `int` | `nextPacketTag()` Obtains the tag of the next packet in the stream.
    `int` | `read()`
    `int` | `read(byte[] buf, int off, int len)`
    `byte[]` | `readAll()`
    `void` | `readFully(byte[] buf)`
    `void` | `readFully(byte[] buf, int off, int len)`
    `Packet` | `readPacket()` Reads the next packet from the stream.

    - ### Methods inherited from class java.io.InputStream

      `mark, markSupported, read, reset, skip`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### BCPGInputStream

          public BCPGInputStream(java.io.InputStream in)

  - ### Method Detail

    - #### available

          public int available()
                        throws java.io.IOException

      Overrides:
        `available` in class `java.io.InputStream`
      Throws:
        `java.io.IOException`

    - #### read

          public int read()
                   throws java.io.IOException

      Specified by:
        `read` in class `java.io.InputStream`
      Throws:
        `java.io.IOException`

    - #### read

          public int read(byte[] buf,
                 int off,
                 int len)
                   throws java.io.IOException

      Overrides:
        `read` in class `java.io.InputStream`
      Throws:
        `java.io.IOException`

    - #### readFully

          public void readFully(byte[] buf,
                       int off,
                       int len)
                         throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readAll

          public byte[] readAll()
                         throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readFully

          public void readFully(byte[] buf)
                         throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### nextPacketTag

          public int nextPacketTag()
                            throws java.io.IOException

      Obtains the tag of the next packet in the stream.
      Returns:
        the `tag number`.
      Throws:
        `java.io.IOException` - if an error occurs reading the tag from the stream.

    - #### readPacket

          public Packet readPacket()
                            throws java.io.IOException

      Reads the next packet from the stream.
      Throws:
        `java.io.IOException`

    - #### close

          public void close()
                     throws java.io.IOException

      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Overrides:
        `close` in class `java.io.InputStream`
      Throws:
        `java.io.IOException`